<html>
<head>
  <title>./5_datausage/main.c</title>
</head>
<body bgcolor="#ffffff" text="#000000">
<pre>
<font color="0000ff"><strong>#include <font color="#008000">&lt;libmcm/mcm-datausage.h&gt;</font></strong></font>
<font color="0000ff"><strong>#include <font color="#008000">&lt;pthread.h&gt;</font></strong></font>
<font color="0000ff"><strong>#include <font color="#008000">&lt;signal.h&gt;</font></strong></font>
<font color="0000ff"><strong>#include <font color="#008000">&lt;stdio.h&gt;</font></strong></font>
<font color="0000ff"><strong>#include <font color="#008000">&lt;stdlib.h&gt;</font></strong></font>
<font color="0000ff"><strong>#include <font color="#008000">&lt;string.h&gt;</font></strong></font>

<strong>void</strong> <font color="#2040a0">usage</font><font color="4444FF">(</font><strong>void</strong><font color="4444FF">)</font> <font color="4444FF"><strong>{</strong></font>
    <font color="#2040a0">printf</font><font color="4444FF">(</font><font color="#008000">&quot;USAGE: <font color="#77dd77">\n</font>&quot;</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <font color="#2040a0">printf</font><font color="4444FF">(</font><font color="#008000">&quot;datausage [Interface Name] &lt;Start Time&gt; &lt;End Time&gt;<font color="#77dd77">\n</font>&quot;</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <font color="#2040a0">printf</font><font color="4444FF">(</font><font color="#008000">&quot;<font color="#77dd77">\t</font>Start: <font color="#77dd77">\&quot;</font>YYYY-MM-DD HH:MM<font color="#77dd77">\&quot;</font> or <font color="#77dd77">\&quot;</font>YYYY-MM-DD<font color="#77dd77">\&quot;</font><font color="#77dd77">\n</font>&quot;</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <font color="#2040a0">printf</font><font color="4444FF">(</font><font color="#008000">&quot;<font color="#77dd77">\t</font>End: <font color="#77dd77">\&quot;</font>YYYY-MM-DD HH:MM<font color="#77dd77">\&quot;</font> or <font color="#77dd77">\&quot;</font>YYYY-MM-DD<font color="#77dd77">\&quot;</font><font color="#77dd77">\n</font>&quot;</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <font color="#2040a0">printf</font><font color="4444FF">(</font><font color="#008000">&quot;datausage reset [Interface Name]<font color="#77dd77">\n</font>&quot;</font><font color="4444FF">)</font><font color="4444FF">;</font>
<font color="4444FF"><strong>}</strong></font>

<strong>int</strong> <font color="#2040a0">datausage</font><font color="4444FF">(</font><strong>char</strong> <font color="4444FF">*</font><font color="#2040a0">interface_name</font>, <strong>char</strong> <font color="4444FF">*</font><font color="#2040a0">start_time</font>, <strong>char</strong> <font color="4444FF">*</font><font color="#2040a0">end_time</font><font color="4444FF">)</font> <font color="4444FF"><strong>{</strong></font>
    <strong>int</strong>                <font color="#2040a0">ret</font> <font color="4444FF">=</font> <font color="#FF0000">0</font><font color="4444FF">;</font>
    <font color="#2040a0">mcm_datausage_info</font> <font color="#2040a0">datausage_info</font><font color="4444FF">;</font>
    <font color="#2040a0">memset</font><font color="4444FF">(</font><font color="4444FF">&amp;</font><font color="#2040a0">datausage_info</font>, <font color="#FF0000">0</font>, <strong>sizeof</strong><font color="4444FF">(</font><font color="#2040a0">mcm_datausage_info</font><font color="4444FF">)</font><font color="4444FF">)</font><font color="4444FF">;</font>

    <strong>if</strong> <font color="4444FF">(</font><font color="4444FF">!</font><font color="#2040a0">start_time</font> <font color="4444FF">&amp;</font><font color="4444FF">&amp;</font> <font color="4444FF">!</font><font color="#2040a0">end_time</font><font color="4444FF">)</font>
        <font color="#2040a0">ret</font> <font color="4444FF">=</font> <font color="#2040a0">mcm_datausage_get_iface_total</font><font color="4444FF">(</font><font color="#2040a0">interface_name</font>, <font color="4444FF">&amp;</font><font color="#2040a0">datausage_info</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <strong>else</strong> <strong>if</strong> <font color="4444FF">(</font><font color="#2040a0">start_time</font> <font color="4444FF">&amp;</font><font color="4444FF">&amp;</font> <font color="4444FF">!</font><font color="#2040a0">end_time</font><font color="4444FF">)</font>
        <font color="#2040a0">ret</font> <font color="4444FF">=</font> <font color="#2040a0">mcm_datausage_get_iface_from</font><font color="4444FF">(</font><font color="#2040a0">interface_name</font>, <font color="#2040a0">start_time</font>, <font color="4444FF">&amp;</font><font color="#2040a0">datausage_info</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <strong>else</strong> <strong>if</strong> <font color="4444FF">(</font><font color="#2040a0">start_time</font> <font color="4444FF">&amp;</font><font color="4444FF">&amp;</font> <font color="#2040a0">end_time</font><font color="4444FF">)</font>
        <font color="#2040a0">ret</font> <font color="4444FF">=</font> <font color="#2040a0">mcm_datausage_get_iface_period</font><font color="4444FF">(</font><font color="#2040a0">interface_name</font>, <font color="#2040a0">start_time</font>, <font color="#2040a0">end_time</font>, <font color="4444FF">&amp;</font><font color="#2040a0">datausage_info</font><font color="4444FF">)</font><font color="4444FF">;</font>

    <font color="#2040a0">printf</font><font color="4444FF">(</font><font color="#008000">&quot;Interface:%s<font color="#77dd77">\n</font>&quot;</font>, <font color="#2040a0">interface_name</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <font color="#2040a0">printf</font><font color="4444FF">(</font><font color="#008000">&quot;Tx: %d byte<font color="#77dd77">\n</font>&quot;</font>, <font color="#2040a0">datausage_info</font>.<font color="#2040a0">tx</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <font color="#2040a0">printf</font><font color="4444FF">(</font><font color="#008000">&quot;Rx: %d byte<font color="#77dd77">\n</font>&quot;</font>, <font color="#2040a0">datausage_info</font>.<font color="#2040a0">rx</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <strong>return</strong> <font color="#2040a0">ret</font><font color="4444FF">;</font>
<font color="4444FF"><strong>}</strong></font>

<strong>int</strong> <font color="#2040a0">main</font><font color="4444FF">(</font><strong>int</strong> <font color="#2040a0">argc</font>, <strong>char</strong> <font color="4444FF">*</font><font color="#2040a0">argv</font><font color="4444FF">[</font><font color="4444FF">]</font><font color="4444FF">)</font> <font color="4444FF"><strong>{</strong></font>
    <strong>int</strong> <font color="#2040a0">ret</font> <font color="4444FF">=</font> <font color="#FF0000">0</font><font color="4444FF">;</font>
    <strong>if</strong> <font color="4444FF">(</font><font color="#2040a0">argc</font> <font color="4444FF">&lt;</font> <font color="#FF0000">2</font><font color="4444FF">)</font> <font color="4444FF"><strong>{</strong></font>
        <font color="#2040a0">usage</font><font color="4444FF">(</font><font color="4444FF">)</font><font color="4444FF">;</font>
        <strong>return</strong> <font color="4444FF">-</font><font color="#FF0000">1</font><font color="4444FF">;</font>
    <font color="4444FF"><strong>}</strong></font>

    <strong>if</strong> <font color="4444FF">(</font><font color="#2040a0">argc</font> <font color="4444FF">=</font><font color="4444FF">=</font> <font color="#FF0000">3</font> <font color="4444FF">&amp;</font><font color="4444FF">&amp;</font> <font color="4444FF">!</font><font color="#2040a0">strcmp</font><font color="4444FF">(</font><font color="#2040a0">argv</font><font color="4444FF">[</font><font color="#FF0000">1</font><font color="4444FF">]</font>, <font color="#008000">&quot;reset&quot;</font><font color="4444FF">)</font><font color="4444FF">)</font>
        <strong>return</strong> <font color="#2040a0">mcm_datausage_reset</font><font color="4444FF">(</font><font color="#2040a0">argv</font><font color="4444FF">[</font><font color="#FF0000">2</font><font color="4444FF">]</font><font color="4444FF">)</font><font color="4444FF">;</font>

    <strong>if</strong> <font color="4444FF">(</font><font color="#2040a0">argc</font> <font color="4444FF">=</font><font color="4444FF">=</font> <font color="#FF0000">4</font><font color="4444FF">)</font>
        <font color="#2040a0">ret</font> <font color="4444FF">=</font> <font color="#2040a0">datausage</font><font color="4444FF">(</font><font color="#2040a0">argv</font><font color="4444FF">[</font><font color="#FF0000">1</font><font color="4444FF">]</font>, <font color="#2040a0">argv</font><font color="4444FF">[</font><font color="#FF0000">2</font><font color="4444FF">]</font>, <font color="#2040a0">argv</font><font color="4444FF">[</font><font color="#FF0000">3</font><font color="4444FF">]</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <strong>else</strong> <strong>if</strong> <font color="4444FF">(</font><font color="#2040a0">argc</font> <font color="4444FF">=</font><font color="4444FF">=</font> <font color="#FF0000">3</font><font color="4444FF">)</font>
        <font color="#2040a0">ret</font> <font color="4444FF">=</font> <font color="#2040a0">datausage</font><font color="4444FF">(</font><font color="#2040a0">argv</font><font color="4444FF">[</font><font color="#FF0000">1</font><font color="4444FF">]</font>, <font color="#2040a0">argv</font><font color="4444FF">[</font><font color="#FF0000">2</font><font color="4444FF">]</font>, <font color="#2040a0">NULL</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <strong>else</strong> <strong>if</strong> <font color="4444FF">(</font><font color="#2040a0">argc</font> <font color="4444FF">=</font><font color="4444FF">=</font> <font color="#FF0000">2</font><font color="4444FF">)</font>
        <font color="#2040a0">ret</font> <font color="4444FF">=</font> <font color="#2040a0">datausage</font><font color="4444FF">(</font><font color="#2040a0">argv</font><font color="4444FF">[</font><font color="#FF0000">1</font><font color="4444FF">]</font>, <font color="#2040a0">NULL</font>, <font color="#2040a0">NULL</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <strong>else</strong>
        <font color="#2040a0">usage</font><font color="4444FF">(</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <strong>return</strong> <font color="#2040a0">ret</font><font color="4444FF">;</font>
<font color="4444FF"><strong>}</strong></font>

</pre>
<hr>
syntax highlighted by <a href="http://www.palfrader.org/code2html">Code2HTML</a>, v. 0.9.1
</body>
</html>
